Agora Java API Reference for Android

Public Types | Public Member Functions | List of all members
agora::media::IVideoFrameObserver Class Referenceabstract

`#include <AgoraMediaBase.h>`

## Public Types
enum | VIDEO_FRAME_PROCESS_MODE { PROCESS_MODE_READ_ONLY, PROCESS_MODE_READ_WRITE }
| The process mode of the video frame: More...
typedef media::base::VideoFrame | VideoFrame

## Public Member Functions
virtual bool | onCaptureVideoFrame (agora::rtc::VIDEO_SOURCE_TYPE sourceType, VideoFrame &videoFrame)=0
| Occurs each time the SDK receives a video frame captured by local devices. More...
virtual bool | onPreEncodeVideoFrame (agora::rtc::VIDEO_SOURCE_TYPE sourceType, VideoFrame &videoFrame)=0
| Occurs each time the SDK receives a video frame before encoding. More...
virtual bool | onMediaPlayerVideoFrame (VideoFrame &videoFrame, int mediaPlayerId)=0
virtual bool | onRenderVideoFrame (const char *channelId, rtc::uid_t remoteUid, VideoFrame &videoFrame)=0
| Occurs each time the SDK receives a video frame sent by the remote user. More...
virtual bool | onTranscodedVideoFrame (VideoFrame &videoFrame)=0
virtual VIDEO_FRAME_PROCESS_MODE | getVideoFrameProcessMode ()
| Occurs each time the SDK receives a video frame and prompts you to set the process mode of the video frame. More...
virtual base::VIDEO_PIXEL_FORMAT | getVideoFormatPreference ()
virtual bool | getRotationApplied ()
| Occurs each time the SDK receives a video frame, and prompts you whether to rotate the captured video. More...
virtual bool | getMirrorApplied ()
| Occurs each time the SDK receives a video frame and prompts you whether or not to mirror the captured video. More...
virtual uint32_t | getObservedFramePosition ()
| Sets the frame position for the video observer. More...
virtual bool | isExternal ()

## Detailed Description

The IVideoFrameObserver class.

## Member Enumeration Documentation

## ◆ VIDEO_FRAME_PROCESS_MODE

enum agora::media::IVideoFrameObserver::VIDEO_FRAME_PROCESS_MODE

The process mode of the video frame:

Enumerator
PROCESS_MODE_READ_ONLY | Read-only mode. In this mode, you do not modify the video frame. The video frame observer is a renderer.
PROCESS_MODE_READ_WRITE | Read and write mode. In this mode, you modify the video frame. The video frame observer is a video filter.

## Member Function Documentation

## ◆ onCaptureVideoFrame()

virtual bool agora::media::IVideoFrameObserver::onCaptureVideoFrame | ( | agora::rtc::VIDEO_SOURCE_TYPE | sourceType,
|  | VideoFrame & | videoFrame
| ) |  |
| pure virtual

Occurs each time the SDK receives a video frame captured by local devices.

You can get raw video data collected by the local device through this callback and preprocess it as needed. Once the preprocessing is complete, you can directly modify `videoFrame` in this callback, and set the return value to `true` to send the modified video data to the SDK. If you need to send the preprocessed data to the SDK, you need to call `getVideoFrameProcessMode` first to set the video processing mode to read and write mode ( PROCESS_MODE_READ_WRITE ). Applicable scenarios: - Preprocess the locally collected video data before it is processed by the SDK. For example, get video data through this callback and process it with filters, watermarks, cropping, rotation, etc.

- Get information about the locally collected video data before it is processed by the SDK. For example, the original width, height, frame rate of the video frame, etc. Call timing: After the successful registration of the video data observer, each time the SDK captures a video frame.

Note
  - If the video data type you get is RGBA, the SDK does not support processing the data of the alpha channel.
  - It is recommended that you ensure the modified parameters in `videoFrame` are consistent with the actual situation of the video frames in the video frame buffer. Otherwise, it may cause unexpected rotation, distortion, and other issues in the local preview and remote video display. The default video format that you get from this callback is YUV420. If you need other formats, you can set the expected data format in the getVideoFormatPreference callback.

Parameters

  sourceType | Video source types, including cameras, screens, or media player. See `VIDEO_SOURCE_TYPE`.
  videoFrame | The video frame. See `VideoFrame`.Note: The default value of the video frame data format obtained through this callback is as follows: Android: I420 or RGB (GLES20.GL_TEXTURE_2D) iOS: I420 or CVPixelBufferRef macOS: I420 or CVPixelBufferRef Windows: YUV420

Returns
  - When the video processing mode is `PROCESS_MODE_READ_ONLY`:
    - `true`: Reserved for future use.
    - `false`: Reserved for future use.
  - When the video processing mode is `PROCESS_MODE_READ_WRITE`:
    - `true`: Sets the SDK to receive the video frame.
    - `false`: Sets the SDK to discard the video frame.

## ◆ onPreEncodeVideoFrame()

virtual bool agora::media::IVideoFrameObserver::onPreEncodeVideoFrame | ( | agora::rtc::VIDEO_SOURCE_TYPE | sourceType,
|  | VideoFrame & | videoFrame
| ) |  |
| pure virtual

Occurs each time the SDK receives a video frame before encoding.

After you successfully register the video frame observer, the SDK triggers this callback each time it receives a video frame. In this callback, you can get the video data before encoding and then process the data according to your particular scenarios. After processing, you can send the processed video data back to the SDK in this callback.

Note
  - If you need to send the preprocessed data to the SDK, you need to call `getVideoFrameProcessMode` first to set the video processing mode to read and write mode ( PROCESS_MODE_READ_WRITE ).
  - To get the video data captured from the second screen before encoding, you need to set `POSITION_PRE_ENCODER` (1 << 2) as a frame position through `getObservedFramePosition`.
  - The video data that this callback gets has been preprocessed, with its content cropped and rotated, and the image enhanced.
  - It is recommended that you ensure the modified parameters in `videoFrame` are consistent with the actual situation of the video frames in the video frame buffer. Otherwise, it may cause unexpected rotation, distortion, and other issues in the local preview and remote video display.

Parameters

  sourceType | The type of the video source. See `VIDEO_SOURCE_TYPE`.
  videoFrame | The video frame. See `VideoFrame`.Note: The default value of the video frame data format obtained through this callback is as follows: Android: I420 or RGB (GLES20.GL_TEXTURE_2D) iOS: I420 or CVPixelBufferRef macOS: I420 or CVPixelBufferRef Windows: YUV420

Returns
  - When the video processing mode is `PROCESS_MODE_READ_ONLY`:
    - `true`: Reserved for future use.
    - `false`: Reserved for future use.
  - When the video processing mode is `PROCESS_MODE_READ_WRITE`:
    - `true`: Sets the SDK to receive the video frame.
    - `false`: Sets the SDK to discard the video frame.

## ◆ onMediaPlayerVideoFrame()

virtual bool agora::media::IVideoFrameObserver::onMediaPlayerVideoFrame | ( | VideoFrame & | videoFrame,
|  | int | mediaPlayerId
| ) |  |
| pure virtual

Occurs each time the SDK receives a video frame decoded by the MediaPlayer.

After you successfully register the video frame observer, the SDK triggers this callback each time a video frame is decoded. In this callback, you can get the video data decoded by the MediaPlayer. You can then pre-process the data according to your scenarios.

After pre-processing, you can send the processed video data back to the SDK by setting the `videoFrame` parameter in this callback.

Note
  - This callback will not be affected by the return values of getVideoFrameProcessMode, getRotationApplied, getMirrorApplied, getObservedFramePosition.
  - On Android, this callback is not affected by the return value of getVideoFormatPreference

Parameters

  videoFrame | A pointer to the video frame: VideoFrame
  mediaPlayerId | ID of the mediaPlayer.

Returns
  Determines whether to ignore the current video frame if the pre-processing fails:
  - true: Do not ignore.
  - false: Ignore, in which case this method does not sent the current video frame to the SDK.

## ◆ onRenderVideoFrame()

virtual bool agora::media::IVideoFrameObserver::onRenderVideoFrame | ( | const char * | channelId,
|  | rtc::uid_t | remoteUid,
|  | VideoFrame & | videoFrame
| ) |  |
| pure virtual

Occurs each time the SDK receives a video frame sent by the remote user.

After you successfully register the video frame observer, the SDK triggers this callback each time it receives a video frame. In this callback, you can get the video data sent from the remote end before rendering, and then process it according to the particular scenarios. The default video format that you get from this callback is YUV420. If you need other formats, you can set the expected data format in the `getVideoFormatPreference` callback.

Note
  - If you need to send the preprocessed data to the SDK, you need to call `getVideoFrameProcessMode` first to set the video processing mode to read and write mode ( PROCESS_MODE_READ_WRITE ).
  - If the video data type you get is RGBA, the SDK does not support processing the data of the alpha channel.
  - It is recommended that you ensure the modified parameters in `videoFrame` are consistent with the actual situation of the video frames in the video frame buffer. Otherwise, it may cause unexpected rotation, distortion, and other issues in the local preview and remote video display.

Parameters

  remoteUid | The user ID of the remote user who sends the current video frame.
  videoFrame | The video frame. See `VideoFrame`.Note: The default value of the video frame data format obtained through this callback is as follows: Android: I420 or RGB (GLES20.GL_TEXTURE_2D) iOS: I420 or CVPixelBufferRef macOS: I420 or CVPixelBufferRef Windows: YUV420
  channelId | The channel ID.

Returns
  - When the video processing mode is `PROCESS_MODE_READ_ONLY`:
    - `true`: Reserved for future use.
    - `false`: Reserved for future use.
  - When the video processing mode is `PROCESS_MODE_READ_WRITE`:
    - `true`: Sets the SDK to receive the video frame.
    - `false`: Sets the SDK to discard the video frame.

## ◆ getVideoFrameProcessMode()

virtual VIDEO_FRAME_PROCESS_MODE agora::media::IVideoFrameObserver::getVideoFrameProcessMode | ( |  | ) |
| virtual

Occurs each time the SDK receives a video frame and prompts you to set the process mode of the video frame.

After you successfully register the video frame observer, the SDK triggers this callback each time it receives a video frame. You need to set your preferred process mode in the return value of this callback.

Returns
  See `VIDEO_FRAME_PROCESS_MODE`.

## ◆ getVideoFormatPreference()

virtual base::VIDEO_PIXEL_FORMAT agora::media::IVideoFrameObserver::getVideoFormatPreference | ( |  | ) |
| virtual

Sets the format of the raw video data output by the SDK.

If you want to get raw video data in a color encoding format other than YUV 420, register this callback when calling `registerVideoFrameObserver`. After you successfully register the video frame observer, the SDK triggers this callback each time it receives a video frame. You need to set your preferred video data in the return value of this callback.

Note
  If you want the video captured by the sender to be the original format, set the original video data format to VIDEO_PIXEL_DEFAULT in the return value. On different platforms, the original video pixel format is also different, for the actual video pixel format, see `VideoFrame`.

Returns
  Sets the video format. See VIDEO_PIXEL_FORMAT.

## ◆ getRotationApplied()

virtual bool agora::media::IVideoFrameObserver::getRotationApplied | ( |  | ) |
| virtual

Occurs each time the SDK receives a video frame, and prompts you whether to rotate the captured video.

If you want to rotate the captured video according to the `rotation` member in the `VideoFrame` class, ensure that you register this callback when calling `registerVideoFrameObserver`. After you successfully register the video frame observer, the SDK triggers this callback each time it receives a video frame. You need to set whether to rotate the video frame in the return value of this callback.

Note
  - On the Android platform, the supported video data formats for this callback are: I420, RGBA, and Texture.
  - On the Windows platform, the supported video data formats for this callback are: I420, RGBA, and TextureBuffer.
  - On the iOS platform, the supported video data formats for this callback are: I420, RGBA, and CVPixelBuffer.
  - On the macOS platform, the supported video data formats for this callback are: I420 and RGBA.

Returns
  Sets whether to rotate the captured video:
  - `true`: Rotate the captured video.
  - `false`: (Default) Do not rotate the captured video.

## ◆ getMirrorApplied()

virtual bool agora::media::IVideoFrameObserver::getMirrorApplied | ( |  | ) |
| virtual

Occurs each time the SDK receives a video frame and prompts you whether or not to mirror the captured video.

If the video data you want to obtain is a mirror image of the original video, you need to register this callback when calling `registerVideoFrameObserver`. After you successfully register the video frame observer, the SDK triggers this callback each time it receives a video frame. You need to set whether or not to mirror the video frame in the return value of this callback.

Note
  - On the Android platform, the supported video data formats for this callback are: I420, RGBA, and Texture.
  - On the Windows platform, the supported video data formats for this callback are: I420, RGBA, and TextureBuffer.
  - On the iOS platform, the supported video data formats for this callback are: I420, RGBA, and CVPixelBuffer.
  - On the macOS platform, the supported video data formats for this callback are: I420 and RGBA.
  - Both this method and the `setVideoEncoderConfiguration` method support setting the mirroring effect. Agora recommends that you only choose one method to set it up. Using both methods at the same time causes the mirroring effect to overlap, and the mirroring settings fail.

Returns
  Sets whether or not to mirror the captured video:
  - `true`: Mirror the captured video.
  - `false`: (Default) Do not mirror the captured video.

## ◆ getObservedFramePosition()

virtual uint32_t agora::media::IVideoFrameObserver::getObservedFramePosition | ( |  | ) |
| virtual

Sets the frame position for the video observer.

After successfully registering the video data observer, the SDK uses this callback to determine whether to trigger `onCaptureVideoFrame`, `onRenderVideoFrame` and `onPreEncodeVideoFrame` callback at each specific video frame processing position, so that you can observe the locally collected video data, the video data sent by the remote end, and the video data before encoding. You can set one or more positions you need to observe by modifying the return value according to your scenario:

- `POSITION_POST_CAPTURER` (1 << 0): The position after capturing the video data, which corresponds to the `onCaptureVideoFrame` callback.
- `POSITION_PRE_RENDERER` (1 << 1): The position of the received remote video data before rendering, which corresponds to the `onRenderVideoFrame` callback.
- `POSITION_PRE_ENCODER` (1 << 2): The position before encoding the video data, which corresponds to the `onPreEncodeVideoFrame` callback.

Note
  - Use '|' (the OR operator) to observe multiple frame positions.
  - This callback observes `POSITION_POST_CAPTURER` (1 << 0) and `POSITION_PRE_RENDERER` (1 << 1) by default.
  - To conserve system resources, you can reduce the number of frame positions that you want to observe.
  - When the video processing mode is `PROCESS_MODE_READ_WRITE` and the observation position is set to `POSITION_PRE_ENCODER` | `POSITION_POST_CAPTURER`, the `getMirrorApplied` does not take effect; you need to modify the video processing mode or the position of the observer.

Returns
  A bit mask that controls the frame position of the video observer. See `VIDEO_MODULE_POSITION`.

## ◆ isExternal()

virtual bool agora::media::IVideoFrameObserver::isExternal | ( |  | ) |
| virtual

Indicate if the observer is for internal use. Note: Never override this function

Returns
  - true: the observer is for external use
  - false: the observer is for internal use